//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <boost/foreach.hpp>
#include "RegexOptions.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

CRegexOption::CRegexOption(int v, const wchar_t* s, const wchar_t* h) :
	m_Value(v), m_CheckBox(new TCheckBox(Application->MainForm))
{
	m_CheckBox->Caption = UnicodeString(s);
	m_CheckBox->Hint = UnicodeString(h);
	m_CheckBox->ShowHint = true;
	m_CheckBox->Tag = v;
}

CRegexOption::~CRegexOption()
{
}

unsigned long CRegexOption::makeFlags(const CRegexOptionTable& Tables)
{
	int Values = 0;
	BOOST_FOREACH(const CRegexOption& i, Tables) {
		if (i.m_CheckBox->Checked) {
			Values |= i.m_Value;
		}
	}
	return Values;
}

UnicodeString CRegexOption::makeFlagText(bool Prefix, const CRegexOptionTable& Tables)
{
	std::unique_ptr<TStringBuilder> sb(new TStringBuilder);

	UnicodeString lit;
	if (Prefix) {
		lit = _T("boost::regex_constants::");
	}

	UnicodeString sep(_T(" | "));

	BOOST_FOREACH(const CRegexOption& i, Tables) {
		if (i.m_CheckBox->Checked  == false) continue;

		if (sb->Length) {
			sb->Append(sep);
		}
		sb->Append(lit);
		sb->Append(i.m_CheckBox->Caption);
	}

	UnicodeString tx = sb->ToString();
	return tx;



}


